<script lang="ts" setup>
import { ref, onMounted, watch } from "vue";
import Chart from "chart.js/auto";
import { useUtilityStore } from "../../stores/utilitycost/utilitycost";
import { useBranchStore } from "@/stores/branch";
import { useAuthStore } from "@/stores/auth";
import utilityCostService from "@/services/utilityCost";

const branchStore = useBranchStore()
const authStore = useAuthStore()
const ucStore = useUtilityStore()
const branches = ref<string[]>([])
const items = ref<{ type: string; price: number }[]>([])
const total_price = ref(0)
const myChart2 = ref<any>(null)

const years = ref<any[]>([])

async function setBranches() {
  await branchStore.getBranches();
  const branchSet = new Set(branchStore.branches.map((branch) => branch.name))
  if (authStore.getCurrentUser()!.role.name === "เจ้าของกิจการ") {
    branches.value = ["all", ...Array.from(branchSet)];
  } else if (authStore.getCurrentUser()!.role.name === "ผู้จัดการร้าน") {
    branches.value = [authStore.getCurrentUser()!.branch.name];
  }
}

async function setYears() {
  const res = await utilityCostService.getYear()
  years.value = res.data.map((year: any) => year.Y_NUMBER)
}

async function updateChartData() {
  total_price.value = 0
  const dataDB = await utilityCostService.getDtailonMonth(
    ucStore.year,
    ucStore.month.id,
    ucStore.branch
  )
  console.log(dataDB.data)
  const types: string[] = []
  const prices: number[] = []
  const itemsArray: { type: string; price: number }[] = []
  if (Array.isArray(dataDB.data)) {
    for (const db of dataDB.data) {
      types.push(db.UCD_TYPE)
      prices.push(db.Total_Price)
      total_price.value += Number(db.Total_Price)
      itemsArray.push({ type: db.UCD_TYPE, price: db.Total_Price })
    }
    items.value = itemsArray
    console.log(items)
  } else {
    console.log('no data')
  }

  if (myChart2.value) {
    myChart2.value.destroy() // Destroy the old chart instance
  }

  const data = {
    labels: types,
    datasets: [
      {
        label: 'ค่าใช้จ่าย',
        data: prices,
        hoverOffset: 4
      }
    ]
  }

  const config = {
    type: 'doughnut',
    data: data,
    options: {
      responsive: true,
      cutoutPercentage: 50
    }
  }

  const ctx = document.getElementById('myChart2')
  if (ctx) {
    myChart2.value = new Chart(ctx, config)
  }
}

onMounted(async () => {
  await setBranches()
  await setYears()
  getCurrentData()
  await updateChartData()
})

function getCurrentData() {
  const thaiMonths = [
    'มกราคม',
    'กุมภาพันธ์',
    'มีนาคม',
    'เมษายน',
    'พฤษภาคม',
    'มิถุนายน',
    'กรกฎาคม',
    'สิงหาคม',
    'กันยายน',
    'ตุลาคม',
    'พฤศจิกายน',
    'ธันวาคม'
  ]
  const currentDate = new Date()
  ucStore.year = currentDate.getFullYear()
  const numMonth = currentDate.getMonth() + 1
  ucStore.month = {
    id: numMonth,
    name: thaiMonths[numMonth - 1]
  }
  ucStore.branch = authStore.getCurrentUser()?.branch.name
}
</script>
<template>

  <v-sheet border class="text-center mx-auto" >
    <v-row style="margin-top: 20px;" class="d-flex justify-center">
        สาขา : {{ ucStore.branch }} ประจําเดือน :
        {{ ucStore.month.name }} ปี : {{ ucStore.year }}
    </v-row>
    <v-container>
      <v-col cols="12">
        <v-row>
          <v-col cols="12" md="6" class="d-flex justify-center">
            <div style="height: 300px; width: 300px">
              <canvas id="myChart2"></canvas>
            </div>
          </v-col>
          <v-col cols="12" md="6">
            <v-card>
              <v-card-title class="text-center" style="font-size: 16;">รายการค่าใช้จ่าย รวม {{ total_price }} บาท </v-card-title>
              <v-card-text>
                <v-table fixed-header style="height: 295px; overflow-y: auto; max-width: 675px">
                  <thead>
                    <tr>
                      <th class="text-left">ประเภท</th>
                      <th class="text-left">ราคา</th>
                    </tr>
                  </thead>
                  <tbody>
                    <tr v-for="(item, index) in items" :key="index">
                      <td>{{ item.type }}</td>
                      <td>{{ item.price }}</td>
                    </tr>
                  </tbody>
                </v-table>
              </v-card-text>
            </v-card>
          </v-col>
        </v-row>
      </v-col>
    </v-container>
      <v-col cols="12">
        <v-card>
          <v-card-text>
            <v-row padding="px-4" style="margin-top: 10px; margin-bottom: 20px">
              <v-col cols="12" md="6">
                <v-select v-model="ucStore.branch" label="สาขา" variant="outlined" :items="branches"></v-select>
              </v-col>
              <v-col cols="12" md="3">
                <v-select v-model="ucStore.month" label="เดือน" variant="outlined" :items="ucStore.thaiMonths"
                  :item-title="'name'" :item-value="'id'"></v-select>
              </v-col>
              <v-col cols="12" md="3">
                <v-select v-model="ucStore.year" label="ปี" variant="outlined" :items="years"></v-select>
              </v-col>
            </v-row>

          </v-card-text>
        </v-card>
      </v-col>
    <v-row>
      <v-col class="d-flex justify-center">
        <v-btn color="blue-darken-1" variant="text" @click="updateChartData()">update</v-btn>
      </v-col>
    </v-row>
  </v-sheet>
</template>
